<?php
/*
Plugin Name: FusionHQ for WordPress
Plugin URI: http://www.fusionhq.com
Description: Synchronize data between FusionHQ and Wordpress.
Version: 0.9.5.1
Author: FusionHQ
Author URI: http://www.fusionhq.com
License: GPL2
*/
/*  Copyright 2010  FusionHQ  (email : developer@fusionhq.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

require_once (ABSPATH . WPINC . '/registration.php');

function vardump($arg)
{
    echo "<pre>";
    var_dump($arg);
    echo "</pre>";
}

if (!function_exists('get_user_meta')) {

    function get_user_meta($userid, $metakey)
    {
        return get_usermeta($userid, $metakey);
    }

}

function array_to_set($arr, $delimeter = ",")
{
    if (is_array($arr) && count($arr) > 0) {
        return implode($delimeter, $arr);
    }
    return '';
}

function set_to_array($set, $delimeter = ",")
{
    if (is_string($set) && $set != '') {
        return explode($delimeter, $set);
    }
    return array();
}

function is_checked($val1, $val2)
{
    if (!isset($val2))
        return false;

    if (is_string($val2))
        return ($val1 === $val2);

    if (is_array($val2) && count($val2) > 0) {
        return in_array($val1, $val2);
    }
    return false;
}

function pair_str_to_array($str, $separator = '=', $delim = ',')
{
    $elems = explode($delim, $str);
    foreach ($elems as $elem => $val) {
        $val = trim($val);
        $nameVal[] = explode($separator, $val);
        $separateindex = strpos($val, $separator);
        $key = substr($val, 0, $separateindex);
        $exactval = substr($val, $separateindex + 1);
        $arr[$key] = $exactval;
    }
    return $arr;
}

function pair_array_to_str($arr, $seperator = '=', $delim = ',')
{
    if (!is_array($arr) || count($arr) == 0) {
        return '';
    }
    $piecearray = array();
    foreach ($arr as $key => $val) {
        $piecearray[] = $key . $seperator . $val;
    }
    return implode($delim, $piecearray);
}

function validate_delay($registerdate, $type = 'NONE', $period = 0, $unit = 'D',
    $release = 0)
{
    switch ($type) {
        case "PERIOD":
            if ($registerdate == 0)
                return false;
            $refdate = $registerdate;
            switch ($unit) {
                case "D":
                    $releasedate = $refdate + $period * 60 * 60 * 24;
                    break;
                case "W":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 7;
                    break;
                case "M":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 30;
                    break;
                case "Y":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 365;
                    break;
                default;
                    $releasedate = $refdate;
                    break;
            }
            $time_diff = $releasedate - $registerdate;
            return ($time_diff < 0);
        case "DATE":
            $time_diff = $release - $registerdate;
            return ($time_diff < 0);
        case "NONE":
            return true;
        default:
            return false;
    }
    return false;
}

function validate_privilege($memship_id, $privilege = '')
{
    if ($privilege == '') {
        return true;
    } else {
        $privilegeArr = set_to_array($privilege, '|');
        if (is_checked($memship_id, $privilegeArr)) {
            return true;
        }
    }
    return false;
}

function validate_access($memship_json, $privilege, $delaytype, $period, $unit,
    $releasedate)
{
    $memshipArr = json_decode($memship_json);
    if (count($memshipArr) > 0) {
        foreach ($memshipArr as $memship) {
            if (validate_privilege($memship->id, $privilege) && validate_delay($memship->
                registerdate, $delaytype, $period, $unit, $releasedate)) {
                return true;
            }
        }
    } else {
        if (validate_privilege(0, $privilege) && validate_delay(0, $delaytype, $period,
            $unit, $releasedate)) {
            return true;
        }
    }
    return false;
}

function fhq_server_request($apimail, $apikey, $todo, $params = null)
{
    $url = "https://www.fusionhq.com/index.php";
    $port = "443";

    $url_parsed = parse_url($url);
    $sock = @fsockopen("ssl://" . $url_parsed['host'], $port, $err_num, $err_str, 30);
    if (!$sock) {
        echo $err_num;
        echo $err_str;
        die("<br>Failed\r\n\r\nCould not connect to {$url_parsed['scheme']}://{$url_parsed['host']} on the port {$port} !");
    }

    $apiemail = $apimail;
    $apikey = $apikey;

    $post_string = "act=api" . "&todo={$todo}" . "&apiemail={$apiemail}" . "&apikey={$apikey}";

    if (is_array($params)) {
        foreach ($params as $key => $val) {
            $post_string .= "&{$key}={$val}";
        }
    }

    fputs($sock, "POST $url_parsed[path] HTTP/1.1\r\n");
    fputs($sock, "Host: $url_parsed[host]\r\n");
    fputs($sock, "Content-type: application/x-www-form-urlencoded\r\n");
    fputs($sock, "Content-length: " . strlen($post_string) . "\r\n");
    fputs($sock, "Connection: close\r\n\r\n");
    fputs($sock, $post_string . "\r\n\r\n");

    while (!feof($sock)) {
        $contents .= @fgets($sock);
    }
    fclose($sock);

    $data = explode("\r\n\r\n", $contents);
    if (preg_match("/Transfer-Encoding: chunked/", $data[0], $matches)) {
        $unchunked = unchunk_http11($data[1]);
        $returnvar = json_decode($unchunked);
    } else {
        $returnvar = json_decode($data[1]);
    }

    if ($returnvar == null)
        return $data[1];
    return $returnvar;
}

function unchunk_http11($data)
{
    $fp = 0;
    $outData = "";
    while ($fp < strlen($data)) {
        $rawnum = substr($data, $fp, strpos(substr($data, $fp), "\r\n") + 2);
        $num = hexdec(trim($rawnum));
        $fp += strlen($rawnum);
        $chunk = substr($data, $fp, $num);
        $outData .= $chunk;
        $fp += strlen($chunk);
    }
    return $outData;
}

function fhq_user_login($user_login)
{
    if ($user_login == "")
        return;

    $username = $_POST['log'];
    $password = $_POST['pwd'];

    $apiemail = get_option('fhq_account');
    $apikey = get_option('fhq_apikey');
    $memsite = get_option('fhq_select_memsite');

    $user_id = username_exists($username);
    $wp_user_level = get_user_meta($user_id, 'wp_user_level', true);

    if ($wp_user_level == 10) {
        if ($_SESSION['redirect'] != null) {
            $_SESSION['force_redirect'] = true;
        }
        return;
    }

    if ($user_id == null) {
        $returnvar = fhq_server_request($apiemail, $apikey, "loginmemsite", array("username" =>
            $username, "password" => $password, "memsite" => $memsite));
        $success = $returnvar->success;
        $username = $returnvar->username;
        $email = $returnvar->email;
        $fname = $returnvar->fname;
        $lname = $returnvar->lname;

        if ($success == true) {
            //add user.
            $user_id = username_exists($username);
            if (!$user_id) {
                $user_id = wp_create_user($username, $password, $email);
                if (is_wp_error($user_id))
                    echo $user_id->get_error_message();
            }
            //add user data form fusionHQ to wordpress database.
            $user_id = username_exists($username);
            update_user_meta($user_id, "first_name", $fname);
            update_user_meta($user_id, "last_name", $lname);

            $memshipArray = array();
            foreach ($returnvar->memship as $val) {
                $tmp["id"] = (int)$val->id;
                $tmp["name"] = $val->name;
                $tmp["registerdate"] = (int)strtotime($val->registerdate);
                $tmp["expiredate"] = (int)strtotime($val->expiredate);
                $memshipArray[] = $tmp;
            }
            $json = json_encode($memshipArray);
            update_user_meta($user_id, "_fhq_memship", $json);
            $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
        } else {
            echo "<div id='message' class='updated fade'><p><strong><font color='#FF0000'>FusionHQ Error Message :</strong> " .
                $returnvar->message . "</font></p></div>";
            return;
        }
    } else {
        $user = get_userdata($user_id);
        if (wp_check_password($password, $user->user_pass, $user->ID)) {
            if (get_user_meta($user_id, "_fhq_memship", true) == null) {
                $returnvar = fhq_server_request($fhq_account, $fhq_apikey, "memlevel_list");
                if ($returnvar->success) {
                    $memshipArray = array();
                    foreach ($returnvar->memship as $val) {
                        $tmp["id"] = (int)$val->id;
                        $tmp["name"] = $val->name;
                        $tmp["registerdate"] = (int)strtotime($val->registerdate);
                        $tmp["expiredate"] = (int)strtotime($val->expiredate);
                        $memshipArray[] = $tmp;
                    }
                    $json = json_encode($memshipArray);
                    update_user_meta($user_id, "_fhq_memship", $json);
                    $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
                }
            } else {
                $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
            }
        } else {
            return;
        }
    }

    if ($_SESSION['redirect'] != null) {
        $_SESSION['force_redirect'] = true;
    }
}

function fhq_save_redirect()
{
    if ($_GET['redirect'] != null)
        $_SESSION['redirect'] = $_GET['redirect'];
}

function fhq_force_redirect($location)
{
    if ($_SESSION['force_redirect']) {
        $redirect = $_SESSION['redirect'];
        unset($_SESSION['force_redirect']);
        unset($_SESSION['redirect']);
        remove_filter('wp_redirect', 'fhq_force_redirect');
        return ($redirect);
    }

    return $location;
}

function fhq_session_init()
{
    session_start();
    global $current_user;
    get_currentuserinfo();
    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
    $_SESSION['is_validate'] = false;
}

function fhq_session_destroy()
{
    $sessin_id = session_id();
    if (!empty($session_id)) {
        session_destroy();
    }
}

// warn user if verification is not complete yet.
function fhq_admin_warnings()
{
    if (!get_option('fhq_account') || !get_option('fhq_apikey') || !get_option('fhq_validation') ||
        get_option('fhq_account') == '' || get_option('fhq_apikey') == '' || get_option
        ('fhq_validation') == '' || get_option('fhq_validation') == 0) {
        echo "
			<div id='fqh-warning' class='updated fade'><p><strong>" . __('FusionHQ API is almost ready.') .
            "</strong> " . sprintf(__('You must <a href="%1$s">verify your FusionHQ API Key</a> for it to work.<br /><br /> If you do not already have a FusionHQ account please go to <a href="http://www.fusionhq.com" target="_blank">www.FusionHQ.com</a> to create one now.'),
            "options-general.php?page=fusionhq-api-option") . "</p></div>
		";
    }
}

// create table when this activate this plugin.
function fhq_db_install()
{
    global $wpdb;
    $table_name = $wpdb->prefix . "fhq_memlevel";
    if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {

        $sql = "CREATE TABLE " . $table_name . " (
			id bigint(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
			memlevel_id bigint(11) NOT NULL,
			memlevel_name VARCHAR( 64 ) NOT NULL
			)ENGINE=MyISAM  DEFAULT CHARSET=utf8;
		";

        require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
    }

    add_option('fhq_account', '');
    add_option('fhq_apikey', '');
    add_option('fhq_memsite', '');
    add_option('fhq_validation', '0');
    add_option('fhq_select_memsite', '0');

    // Need to enable xml_rpc value
    update_option('enable_xmlrpc', '1');
}

register_activation_hook(__file__, 'fhq_db_install');

// uninstall plugin and delete table from database.
function fhq_db_uninstall()
{
    global $wpdb;
    $table_name = $wpdb->prefix . "fhq_memlevel";
    $sql = "DROP TABLE IF EXISTS " . $table_name;
    $e = $wpdb->query($sql);

    $table_name = $wpdb->prefix . "postmeta";
    $sql = "DELETE FROM " . $table_name . " WHERE meta_key LIKE '_fhq_%';";
    $e = $wpdb->query($sql);

    $table_name = $wpdb->prefix . "usermeta";
    $sql = "DELETE FROM " . $table_name . " WHERE meta_key LIKE '_fhq_%';";
    $e = $wpdb->query($sql);

    delete_option('fhq_account');
    delete_option('fhq_apikey');
    delete_option('fhq_select_memsite');
    delete_option('fhq_memsite');
    delete_option('fhq_validation');
}

register_deactivation_hook(__file__, 'fhq_db_uninstall');

function fhq_plugins_menu()
{
    add_options_page('FusionHQ API Settings', 'FusionHQ API', 'manage_options',
        'fusionhq-api-option', 'fhq_plugin_options');
}

function fhq_plugin_options()
{
    echo '<div class="wrap">';
    include_once "fusionpress_config.php";
    echo '</div>';
}

function fhq_customfield()
{
    if (!is_admin()) {
        return false;
    }

    echo '<div class="wrap">';
    include_once "fusionpress_customfield.php";
    echo '</div>';
}

/*
function fhq_validate_access_action($post)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        return;
    }

    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);

    $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
    if ($access_level == 'PRIVATE') {
        $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
    } else {
        $privilege = '';
    }
    $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
    $period = get_post_meta($post->ID, '_fhq_delay_period', true);
    $unit = get_post_meta($post->ID, '	_fhq_delay_periodunit', true);
    if ($delaytype == "NONE") {
        $releasedate = 0;
    } else {
        $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
    }

    $_SESSION['is_validate'] = validate_access($_SESSION['memship'], $privilege, $delaytype,
        $period, $unit, $releasedate);
    
 
    if (!$_SESSION['is_validate']) {
	     $post->post_title = '';
		$post->comment_status = 'closed';
		$post->ping_status    = 'closed';
    }
    
}
*/

function fhq_validate_access_element($privilege, $delaytype, $period, $unit, $releasedate)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        return;
    }

    $_SESSION['is_validate'] = validate_access($_SESSION['memship'], $privilege, $delaytype,
        $period, $unit, $releasedate);
}

function fhq_validate_access_filter($content)
{
    if ($_SESSION['is_validate']) {
        return $content;
    } else {
        return 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
            '">here</a> to login.';
    }
}

function fhq_validate_comment_filter($comments){
	if($_SESSION['is_validate']){
		return $comments;
	}else{
		return array();	
	}
}



function fhq_generate_menu($menu)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10 ) {
        return $menu;
    }

    $exclude_array = array();
    $page_array = get_pages();
    foreach ($page_array as $post) {
        $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
        if ($access_level == 'PRIVATE') {
            $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
        } else {
            $privilege = '';
        }
        $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
        $period = get_post_meta($post->ID, '_fhq_delay_period', true);
        $unit = get_post_meta($post->ID, '	_fhq_delay_periodunit', true);
        if ($delaytype == "NONE") {
            $releasedate = 0;
        } else {
            $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
        }
        if (!validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit,
            $releasedate)) {
            $exclude_array[] = $post->ID;
        }
    }

    $html = str_get_html($menu);
    foreach ($exclude_array as $post_id) {
        $html->find('li.page-item-' . $post_id, 0)->outertext = '';
    }

    return $html;
}

if (is_admin()) {
    include_once "fusionpress_customfield.php";
}

include_once "simple_html_dom.php";

function fhq_validate_posts_action($posts){
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        return $posts;
    }
   
    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
	
	$postCount = count($posts);
	$invalidCount = 0;
	$validCount = 0;
	
	foreach($posts as $post){
		
	    $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
	    if ($access_level == 'PRIVATE') {
		   $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
	    } else {
		   $privilege = '';
	    }
	    $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
	    $period = get_post_meta($post->ID, '_fhq_delay_period', true);
	    $unit = get_post_meta($post->ID, '_fhq_delay_periodunit', true);
	    if ($delaytype == "NONE") {
		   $releasedate = 0;
	    } else {
		   $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
	    }
	
	    $isValidate = validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit, $releasedate);
	    
	    if (!$isValidate) {
		    $invalidCount = $invalidCount + 1;
		    $post->post_content = 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
            '">here</a> to login.';
		    $post->comment_status = 'closed';
		    $post->ping_status    = 'closed';
	    }else{
		    $validPosts[$validCount] = $post;
		    $validCount++;	    
	    }
	}
	
	if($invalidCount < $postCount){
		return $validPosts;
	}else{
		$invalidPosts[0] = $posts[0];
		$invalidPosts[0]->post_author = "1";
		$invalidPosts[0]->post_date = date("Y-m-d H:i:s");
		$invalidPosts[0]->post_title = "Forbidden content";
		$invalidPosts[0]->post_name = "";
		$invalidPosts[0]->post_content = 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
             '">here</a> to login.';
		return $invalidPosts;
	}
}

function fhq_generate_category_list($arg){
	global $current_user;
     get_currentuserinfo();
	if($current_user->wp_user_level == 10){
		return $arg;
	}
	
	$_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
	
	global $wpdb;
	
	$categories = $wpdb->get_results("select wp_terms.name , wp_terms.slug from wp_terms , wp_term_taxonomy 
						   where wp_terms.term_id = wp_term_taxonomy.term_id 
						   and wp_term_taxonomy.taxonomy = 'category' 
						   and wp_term_taxonomy.count <> '0' ");

	$arg = "<ul>";
	foreach($categories as $cat){
		$cat_count= 0;
		$posts = $wpdb->get_results("select * from wp_posts , wp_term_relationships , wp_terms , wp_term_taxonomy 
								  where wp_posts.post_status = 'publish' 
								  and wp_posts.ID = wp_term_relationships.object_id 
								  and wp_term_relationships.term_taxonomy_id = wp_term_taxonomy.term_taxonomy_id
								  and wp_term_taxonomy.term_id = wp_terms.term_id
								  and wp_terms.name = '".$cat->name."' ");
		foreach($posts as $post){
			$access_level = get_post_meta($post->ID, '_fhq_access_level', true);
		     if ($access_level == 'PRIVATE') {
			    $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
		     } else {
			    $privilege = '';
		     }
		     $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
		     $period = get_post_meta($post->ID, '_fhq_delay_period', true);
		     $unit = get_post_meta($post->ID, '_fhq_delay_periodunit', true);
		     if ($delaytype == "NONE") {
		  	    $releasedate = 0;
		     } else {
			    $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
		     }
			$isValidate = validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit, $releasedate);
			if($isValidate == true){
				$cat_count++;
			}
		}
		if($cat_count!=0){
			$path = home_url()."/category/".$cat->slug;
			$arg .= "<li><a href='".$path."'>".$cat->name." (".$cat_count.")</a></li>"; 
		}
	}
	$arg .= "</ul>";
	
	return $arg;
}

function fhq_xmlrpc_methods($methods){
	$methods['wp-fhq.getCategoryByID'] = 'fhq_getCategoryByID_function';
	$methods['wp-fhq.updateCategory'] = 'fhq_updateCategory_function';
	return $methods;
}

function fhq_getCategoryByID_function($args){
	// Parse the arguments, assuming they're in the correct order
	$blog_id				= (int) $args[0];
	$username				= $args[1];
	$password				= $args[2];
	$category_id			= (int) $args[3];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	$res_cat = get_term($category_id,'category');

	return $res_cat;
}

function fhq_updateCategory_function($args){
	// Parse the arguments, assuming they're in the correct order
	$blog_id				= (int) $args[0];
	$username				= $args[1];
	$password				= $args[2];
	$category_id			= (int) $args[3];
	$update_args			= $args[4];
	
	//return $update_args;
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	// Make sure the user is allowed to add a category.
	if ( !current_user_can("manage_categories") )
		return(new IXR_Error(401, __("Sorry, you do not have the right to add a category.")));
	
	if($update_args['id']!=""){
		global $wpdb;
		$wpdb->update( 'wp_terms', array( 'term_id' => $update_args['id']), array( 'term_id' => $category_id ), array( '%d' ), array( '%d' ) );
		$wpdb->update( 'wp_term_taxonomy', array( 'term_id' => $update_args['id']), array( 'term_id' => $category_id ), array( '%d' ), array( '%d' ) );
	}else{
		wp_update_term( $category_id, 'category', $update_args );
	}
	
	return true;
	
}

// include jquery core and jquery-ui datepicker
$plugindir = WP_PLUGIN_URL . '/' . str_replace(basename(__file__), "",
    plugin_basename(__file__));
wp_enqueue_script("jquery");
wp_register_script('jquery-datepicker', $plugindir . 'js/ui.datepicker.min.js');
wp_enqueue_script('jquery-datepicker');
wp_register_style('jquery-datepicker', $plugindir . 'css/jquery-ui.css');
wp_enqueue_style('jquery-datepicker');
wp_register_script('fusionhq-customfield-script', $plugindir .
    'fusionpress_customfield.js');
wp_enqueue_script('fusionhq-customfield-script');
wp_register_style('fhq-wordpress', $plugindir . 'css/wordpress.css');
wp_enqueue_style('fhq-wordpress');

// add this plugin to administration menu
add_action('plugins_loaded', 'fhq_session_init');
add_action('admin_menu', 'fhq_plugins_menu');
add_action('admin_notices', 'fhq_admin_warnings');

add_filter('wp_authenticate', 'fhq_user_login');
add_filter('wp_redirect', 'fhq_force_redirect');
add_action('login_form', 'fhq_save_redirect');
add_action('wp_logout', 'fhq_session_destroy');

//add_action('the_post', 'fhq_validate_access_action', 1, 2);
add_filter('the_posts', 'fhq_validate_posts_action', 1, 2);
//add_filter('the_content', 'fhq_validate_access_filter', 1, 2);
add_filter('comments_array', 'fhq_validate_comment_filter', 1, 2);
add_filter('wp_list_pages', 'fhq_generate_menu', 1, 2);
add_filter('wp_list_categories','fhq_generate_category_list');

add_filter('xmlrpc_methods','fhq_xmlrpc_methods');

?>