<?
if ( !class_exists('myCustomFields') ) {

	class myCustomFields {
		/**
		* @var  string  $prefix  The prefix for storing custom fields in the postmeta table
		*/
		var $prefix = '_fhq_';
		/**
		* @var  array  $customFields  Defines the custom fields available
		*/
		var $customFields =	array(
			array(
				"name"			=> "",
				"title"			=> '<font style="font-size:1.3em;font-weight:bold;">Access Level :</font>',
				"description"		=> "",
				"type"			=> "textlabel",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "access_level",
				"id"				=> "access_level_PUBLIC",
				"value"			=> "PUBLIC",
				"title"			=> "<strong>Public</strong>",
				"description"		=> "Give access to everyone",
				"type"			=> "radio",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "access_level",
				"id"				=> "access_level_PRIVATE",
				"value"			=> "PRIVATE",
				"title"			=> "<strong>Private</strong>",
				"description"		=> "Give access to the following membership levels",
				"type"			=> "radio",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "checkbox",
				"title"			=> "Checkbox",
				"description"		=> "",
				"type"			=> "checkbox-accesslevel",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "",
				"title"			=> '<font style="font-size:1.3em;font-weight:bold;">Delay Option:</font>',
				"description"		=> "",
				"type"			=> "textlabel",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "delay_type",
				"id"				=> "delay_type_NONE",
				"value"			=> "NONE",
				"title"			=> "None",
				"description"		=> "Content will be visible immediately after subscribers register",
				"type"			=> "radio",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "delay_type",
				"id"				=> "delay_type_PERIOD",
				"value"			=> "PERIOD",
				"title"			=> "Delay for",
				"description"		=> "Specify how long content will be visible for subscribers",
				"type"			=> "delay_period",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			),
			array(
				"name"			=> "delay_type",
				"id"				=> "delay_type_DATE",
				"value"			=> "DATE",
				"title"			=> "Release at",
				"description"		=> "Specify your release date in format yyyy-mm-dd",
				"type"			=> "delay_releasedate",
				"scope"			=> array( "post", "page" ),
				"capability"		=> array( "edit_posts", "edit_pages" )
			)
		);
		/**
		* PHP 4 Compatible Constructor
		*/
		function myCustomFields() { $this->__construct(); }
		/**
		* PHP 5 Constructor
		*/
		function __construct() {
			add_action( 'admin_menu', array( &$this, 'createCustomFields' ) );
			add_action( 'save_post', array( &$this, 'saveCustomFields' ), 1, 2 );
			// Comment this line out if you want to keep default custom fields meta box
			//add_action( 'do_meta_boxes', array( &$this, 'removeDefaultCustomFields' ), 10, 3 );
		}
		/**
		* Remove the default Custom Fields meta box
		*/
		function removeDefaultCustomFields( $type, $context, $post ) {
			foreach ( array( 'normal', 'advanced', 'side' ) as $context ) {
				remove_meta_box( 'postcustom', 'post', $context );
				remove_meta_box( 'postcustom', 'page', $context );
				//Use the line below instead of the line above for WP versions older than 2.9.1
				//remove_meta_box( 'pagecustomdiv', 'page', $context );
			}
		}
		/**
		* Create the new Custom Fields meta box
		*/
		function createCustomFields() {
			if ( function_exists( 'add_meta_box' ) ) {
				add_meta_box( 'fhq-custom-fields', 'FusionHQ Site Manager', array( &$this, 'displayCustomFields' ), 'page', 'normal', 'high' );
				add_meta_box( 'fhq-custom-fields', 'FusionHQ Site Manager', array( &$this, 'displayCustomFields' ), 'post', 'normal', 'high' );
			}
		}
		/**
		* Display the new Custom Fields meta box
		*/
		function displayCustomFields() {
			global $post;
			?>
			<div class="form-wrap">
				<?php
				wp_nonce_field( 'fhq-custom-fields', 'fhq-custom-fields_wpnonce', false, true );
				foreach ( $this->customFields as $customField ) {
					// Check scope
					$scope = $customField[ 'scope' ];
					$output = false;
					foreach ( $scope as $scopeItem ) {
						switch ( $scopeItem ) {
							case "post": {
								// Output on any post screen
								if ( basename( $_SERVER['SCRIPT_FILENAME'] )=="post-new.php" || $post->post_type=="post" )
									$output = true;
								break;
							}
							case "page": {
								// Output on any page screen
								if ( basename( $_SERVER['SCRIPT_FILENAME'] )=="page-new.php" || $post->post_type=="page" )
									$output = true;
								break;
							}
						}
						if ( $output ) break;
					}
					// Check capability
					//if ( !current_user_can( $customField['capability'], $post->ID ) )
					if( is_array( $customField['capability'] ) ) {
						foreach( $customField['capability'] as $capability ) {
							if( !current_user_can( $capability, $post->ID ) ) {
								$output = false;
								break;
							}
						}
					} else {
						if( !current_user_can( $customField['capability'], $post->ID ) )
							$output = false;
					}

					// Output if allowed
					if ( $output ) { ?>
						<div style="padding:5px;">
							<?php
							if($customField['name'] == 'delay_type' && !get_post_meta( $post->ID, $this->prefix . $customField['name'], true )) {
								update_post_meta( $post->ID, $this->prefix . $customField['name'], 'NONE' );
							} else if($customField['name'] == 'access_level' && !get_post_meta( $post->ID, $this->prefix . $customField['name'], true )) {
								update_post_meta( $post->ID, $this->prefix . $customField['name'], 'PUBLIC' );
							}

							switch ( $customField[ 'type' ] ) {
								case "checkbox-accesslevel": {
									global $wpdb;
									$sql_result = $wpdb->get_results("select * from {$wpdb->prefix}fhq_memlevel");
									$protectedfor = get_post_meta( $post->ID, $this->prefix . "protectedfor", true );
									if(!$protectedfor) {
										update_post_meta( $post->ID, $this->prefix . 'protectedfor', '' );
										$protectedfor = '';
									}
									$protectedforArray = set_to_array($protectedfor,"|");
									echo "<div id='div-accesslevelchkbox' style='padding-left:15px;display:".(count($protectedforArray)>0 ? "inline" : "none").";' >";
									$record_count = count($sql_result); $i = 0;
									foreach($sql_result as $val){
										echo '<span style="text-align:left;display:block;padding:2px 0;">';
										echo '<label for="' . $this->prefix . $customField[ 'name' ] . "_" . $val->memlevel_id .'" style="width:auto;display:inline;"><input type="checkbox" name="' . $this->prefix . $customField['name'] . "[]". '" id="' . $this->prefix . $customField['name'] . "_" . $val->memlevel_id . '" class="access-level" value="'.$val->memlevel_id.'"';
										if ( is_checked( $val->memlevel_id , $protectedforArray ) )
											echo ' checked="checked"';
										echo '" />&nbsp;' . $val->memlevel_name . '</label>';
										echo '</span>';
									}
									echo "</div>";
									break;
								}
								case "delay_period": {
									echo '<input type="radio" name="' . $this->prefix . $customField['name'] . '" id="' . $this->prefix . $customField['id'] . '" value="'.$customField['value'].'"';
									if ( get_post_meta( $post->ID, $this->prefix . $customField['name'], true ) ==  $customField['value']) {
										echo ' checked="checked"';
									}
									echo '" style="width: auto;" />';
									echo '<label for="' . $this->prefix . $customField[ 'id' ] .'" style="display:inline;">' . $customField[ 'title' ] . '</label>';
									$selected[get_post_meta( $post->ID, $this->prefix . 'delay_periodunit', true )] = 'selected="selected"';
									echo '&nbsp;<input type="text" name="'.$this->prefix.'delay_period" size="10" style="width:60px;" value="'.get_post_meta( $post->ID, $this->prefix . 'delay_period', true ).'" />&nbsp;';
									echo '<select name="'.$this->prefix.'delay_periodunit">
										<option value="D" '.$selected["D"].' >Day(s)</option>
										<option value="W" '.$selected["W"].' >Week(s)</option>
										<option value="M" '.$selected["M"].' >Month(s)</option>
										<option value="Y" '.$selected["Y"].' >Year(s)</option>
										</select>';
									break;
								}
								case "delay_releasedate": {
									echo '<input type="radio" name="' . $this->prefix . $customField['name'] . '" id="' . $this->prefix . $customField['id'] . '" value="'.$customField['value'].'"';
									if ( get_post_meta( $post->ID, $this->prefix . $customField['name'], true ) ==  $customField['value']) {
										echo ' checked="checked"';
									}

									echo '" style="width: auto;" />';
									echo '<label for="' . $this->prefix . $customField[ 'id' ] .'" style="display:inline;">' . $customField[ 'title' ] . '</label>';
									$timestamp = get_post_meta( $post->ID, $this->prefix . "delay_releasedate", true );
									if($timestamp == NULL) $timestamp = mktime();
									echo '&nbsp;<input type="text" id="datepicker" name="'.$this->prefix . "delay_releasedate" .'" style="width:150px;" value="'.date("Y-m-d", $timestamp).'" />';
									break;
								}
								case "radio": {
									echo '<input type="radio" name="' . $this->prefix . $customField['name'] . '" id="' . $this->prefix . $customField['id'] . '" value="'.$customField['value'].'"';
									if ( get_post_meta( $post->ID, $this->prefix . $customField['name'], true ) ==  $customField['value']) {
										echo ' checked="checked"';
									}

									echo '" style="width: auto;" />';
									echo '<label for="' . $this->prefix . $customField[ 'id' ] .'" style="display:inline;">' . $customField[ 'title' ] . '</label>';
									break;
								}
								case "checkbox": {
									echo '<label for="' . $this->prefix . $customField[ 'name' ] .'" style="display:inline;"><b>' . $customField[ 'title' ] . '</b></label>&nbsp;&nbsp;';
									echo '<input type="checkbox" name="' . $this->prefix . $customField['name'] . '" id="' . $this->prefix . $customField['name'] . '" value="yes" checked="checked" ';
									if ( get_post_meta( $post->ID, $this->prefix . $customField['name'], true ) == "yes" )
										echo ' checked="checked"';
									echo '" style="width: auto;" />';
									break;
								}
								case "combobox": {
									echo '<label for="' . $this->prefix . $customField[ 'name' ] .'" style="display:inline;"><b>' . $customField[ 'title' ] . '</b></label>&nbsp;&nbsp;';
									echo '<select name="' . $this->prefix . $customField['name'] . '" id="' . $this->prefix . $customField['name'] . '" >';
									for($i=0;$i<$customField['dataCount'];$i++){
										echo '<option value="" ></option>';
									}
									echo '</select>';
									break;
								}
								case "textlabel": {
									echo $customField[ 'title' ];
									break;
								}
								case "textarea":
								case "wysiwyg": {
									// Text area
									echo '<label for="' . $this->prefix . $customField[ 'name' ] .'"><b>' . $customField[ 'title' ] . '</b></label>';
									echo '<textarea name="' . $this->prefix . $customField[ 'name' ] . '" id="' . $this->prefix . $customField[ 'name' ] . '" columns="30" rows="3">' . htmlspecialchars( get_post_meta( $post->ID, $this->prefix . $customField[ 'name' ], true ) ) . '</textarea>';
									// WYSIWYG
									if ( $customField[ 'type' ] == "wysiwyg" ) { ?>
										<script type="text/javascript">
											jQuery( document ).ready( function() {
												jQuery( "<?php echo $this->prefix . $customField[ 'name' ]; ?>" ).addClass( "mceEditor" );
												if ( typeof( tinyMCE ) == "object" && typeof( tinyMCE.execCommand ) == "function" ) {
													tinyMCE.execCommand( "mceAddControl", false, "<?php echo $this->prefix . $customField[ 'name' ]; ?>" );
												}
											});
										</script>
									<?php }
									break;
								}
								default: {
									// Plain text field
									echo '<label for="' . $this->prefix . $customField[ 'name' ] .'"><b>' . $customField[ 'title' ] . '</b></label>';
									echo '<input type="text" name="' . $this->prefix . $customField[ 'name' ] . '" id="' . $this->prefix . $customField[ 'name' ] . '" value="' . htmlspecialchars( get_post_meta( $post->ID, $this->prefix . $customField[ 'name' ], true ) ) . '" size="10" />';
									break;
								}
							}
							?>
							<?php if ( $customField[ 'description' ] ) echo '&nbsp;<span class="description" style="vertical-align:middle;">' . $customField[ 'description' ] . '</span>'; ?>
						</div>
					<?php
					}
				} ?>
			</div>
			<?php
		}
		/**
		* Save the new Custom Fields values
		*/
		function saveCustomFields( $post_id, $post ) {
			if ( !wp_verify_nonce( $_POST[ 'fhq-custom-fields_wpnonce' ], 'fhq-custom-fields' ) )
				return;
			if ( !current_user_can( 'edit_posts', $post_id ) )
				return;
			if ( !current_user_can( 'edit_pages', $post_id ) )
				return;
			if ( $post->post_type != 'page' && $post->post_type != 'post' )
				return;
			foreach ( $this->customFields as $customField ) {
				$can_edit = true;
				if( is_array( $customField['capability'] ) ) {
					foreach( $customField['capability'] as $capability ) {
						if( !current_user_can( $capability, $post_id ) ) {
							$can_edit = false;
						}
					}
				} else {
					if( !current_user_can( $customField['capability'], $post_id ) )
						$can_edit = false;
				}
				if ( $can_edit ) {
					if ( $customField['type'] == "checkbox-accesslevel" ){
						global $wpdb;
						$result = '';
						if($_POST[ $this->prefix . "access_level" ] == "PRIVATE") {
							$tmp = array();
							if($_POST[ $this->prefix . $customField['name'] ] != NULL) {
								$tmp = $_POST[ $this->prefix . $customField['name'] ];
							}
							$result = array_to_set($tmp,"|");
						}
						update_post_meta( $post_id, $this->prefix . "protectedfor" , $result );
					} else if ( $customField['name'] == "delay_type"){
						update_post_meta( $post_id, $this->prefix . "delay_type" , $_POST[$this->prefix .'delay_type'] );
						update_post_meta( $post_id, $this->prefix . "delay_period" , $_POST[$this->prefix .'delay_period'] );
						update_post_meta( $post_id, $this->prefix . "delay_periodunit" , $_POST[$this->prefix .'delay_periodunit'] );
						update_post_meta( $post_id, $this->prefix . "delay_releasedate" , strtotime($_POST[$this->prefix .'delay_releasedate']) );
					} else if ( !empty( $_POST[ $this->prefix . $customField['name'] ] ) && is_string( $_POST[ $this->prefix . $customField['name'] ] ) && trim( $_POST[ $this->prefix . $customField['name'] ] ) ) {
						$value = $_POST[ $this->prefix . $customField['name'] ];
						// Auto-paragraphs for any WYSIWYG
						if ( $customField['type'] == "wysiwyg" ) $value = wpautop( $value );
						update_post_meta( $post_id, $this->prefix . $customField[ 'name' ], $value );
					} else {
						delete_post_meta( $post_id, $this->prefix . $customField[ 'name' ] );
					}
				}
			}
		}

	} // End Class

} // End if class exists statement

// Instantiate the class
if ( class_exists('myCustomFields') ) {
	$myCustomFields_var = new myCustomFields();
}
?>